/*
   Send a LANC command to a video camera.
   2013, ACC*Software, Planed by 管理人；宏哉, Programed by 松ケン,
      http://Next-Zero.com
  cf. http://controlyourcamera.blogspot.com/2011/02/arduino-controlled-video-recording-over.html
*/
//受信側  xiaoバージョン

#define MP_speed_high 'V'
#define MP_speed_low 'W'
#define speed_high 'X'
#define speed_mid 'Y'
#define speed_low 'Z'

#define LEFT_BOT 'A'
#define RIGHT_BOT 'B'
#define UP_BOT 'C'
#define DOWN_BOT 'D'
#define LEFT_BOT_off 'a'
#define RIGHT_BOT_off 'b'
#define UP_BOT_off 'c'
#define DOWN_BOT_off 'd'
#define Zoom_far_high 'E'
#define Zoom_far_mid 'F'
#define Zoom_far_low 'G'
#define Zoom_far_off 'e'
#define Zoom_near_high 'H'
#define Zoom_near_mid 'I'
#define Zoom_near_low 'J'
#define Zoom_near_off 'h'
#define AFMF 'K'
#define HTBT 'L'
#define LANC 'M'
#define ASS1 'N'  //Victor 専用ASSIGN_1
#define TELE 'O'
#define WIDE 'P'
#define TELE_off 'o'
#define WIDE_off 'p'

#define cmdPin 4
#define lancPin 5
#define linkLED 8
#define speedPin 10
#define LED 12u
#define UpPin 2
#define DownPin 1
#define LeftPin 3
#define RightPin 0

#define XBEE_SERIAL Serial1 // select which Serial to communicate with XBee
char serialData;
//char ZoomSpeed = speed_high;
char MP_speed = MP_speed_low;
bool LANC_HTBT = false;

int bitDuration = 104; //Duration of one LANC bit in microseconds.
unsigned long link_timer; //link時間チェック用
bool xbee_err = true;
String xbee_ret;

int zoom_far_on = 0; //off:0 high:1 mid:2 low:3
int zoom_near_on = 0;
int tele_on = 0; //0:off 1:on
int wide_on = 0;
int up_on = 0;
int down_on = 0;
int right_on = 0;
int left_on = 0;

void send(unsigned char cmd1, unsigned char cmd2) ;

void setup()
{
setup_start:
  //LANC CONTROL PINs
  pinMode(lancPin, INPUT); //listens to the LANC line
  pinMode(cmdPin, OUTPUT); //writes to the LANC line
  pinMode(linkLED, OUTPUT); //write to the link
  digitalWrite(cmdPin, LOW); //set LANC line to +5V

  //MP-101 CONTROL PINs
  pinMode(UpPin, OUTPUT); //writes to the MP-101 line
  digitalWrite(UpPin, LOW);
  pinMode(DownPin, OUTPUT); //writes to the MP-101 line
  digitalWrite(DownPin, LOW);
  pinMode(LeftPin, OUTPUT); //writes to the MP-101 line
  digitalWrite(LeftPin, LOW);
  pinMode(RightPin, OUTPUT); //writes to the MP-101 line
  digitalWrite(RightPin, LOW);
  pinMode(LED, OUTPUT);

  bitDuration = bitDuration - 8; //Writing to the digital port takes about 8 microseconds so only 96 microseconds are left till the end of each bit
  Serial1.begin(38400);
  //Serial.begin(38400);

  digitalWrite(linkLED, HIGH); //Xbeeが安定するまでの時間稼ぎを兼ねて
  delay(800);
  digitalWrite(linkLED, LOW);

  if (xbeecmd_enter()) // enter to AT command mode
  {
    if (xbeecmd_CMD("ATOP"))          //xbeeネットワーク確認
    {
      if (xbee_ret.startsWith("777"))//xbeeとの接続確認　OKならLED速点滅
      {
        for (int i = 0; i < 20; i++) {
          digitalWrite(linkLED, HIGH); //点滅
          delay(50);
          digitalWrite(linkLED, LOW); //点滅
          delay(50);
        }
      }
      else
      {
        xbeecmd_CMD("ATNR");//xbeeネットワーク初期化　この時点で親機は立ち上げてから1分以内でないと接続にいけない
      }
    }
    else
    {
      for (int i = 0; i < 10; i++)
      { //xbeeとarduinoの通信エラー速点滅で再起動 * * *ー 　xbeeのリセットからの起動が遅れた場合
        digitalWrite(linkLED, HIGH); //点滅
        delay(100);
        digitalWrite(linkLED, LOW); //点滅
        delay(200);

        digitalWrite(linkLED, HIGH); //点滅
        delay(100);
        digitalWrite(linkLED, LOW); //点滅
        delay(200);

        digitalWrite(linkLED, HIGH); //点滅
        delay(100);
        digitalWrite(linkLED, LOW); //点滅
        delay(200);

        digitalWrite(linkLED, HIGH); //点滅
        delay(500);
        digitalWrite(linkLED, LOW); //点滅
        delay(200);
      }
      goto setup_start; //マナー違反かもしれないけど強制再起動。
    }
  }
  else
  {
    for (int i = 0; i < 10; i++)
    { //xbeeとarduinoの通信エラーなので速点滅で再起動 * * -　　子機内でのハード的なトラブル発生。
      digitalWrite(linkLED, HIGH); //点滅
      delay(100);
      digitalWrite(linkLED, LOW); //点滅
      delay(200);

      digitalWrite(linkLED, HIGH); //点滅
      delay(100);
      digitalWrite(linkLED, LOW); //点滅
      delay(200);

      digitalWrite(linkLED, HIGH); //点滅
      delay(500);
      digitalWrite(linkLED, LOW); //点滅
      delay(200);
    }
    goto setup_start;
  }
  link_timer = millis();

}
void loop()
{

  //LANCが生きているときだけ
  if  (pulseIn(lancPin, HIGH, 10000) > 0) {
    if (zoom_far_on == 1) {
      send(B00101000, B00001010); //send a command to camera Zoom tele high
    }
    else if (zoom_far_on == 2) {
      send(B00101000, B00000110); //send a command to camera Zoom tele mid
    }
    else if (zoom_far_on == 3) {
      send(B00101000, B00000010); //send a command to camera Zoom tele low
    }

    if (zoom_near_on == 1) {
      send(B00101000, B00011010); //send a command to camera Zoom wide high
    }
    else if (zoom_near_on == 2) {
      send(B00101000, B00010110); //send a command to camera Zoom wide mid
    }
    else if (zoom_near_on == 3) {
      send(B00101000, B00010010); //send a command to camera Zoom wide low
    }

    if (wide_on == 1) {
      send(B00101000, B01000111); //send a command to camera Focus near
    }
    if (tele_on == 1) {
      send(B00101000, B01000101); //send a command to camera Focus far
    }

  }


  if (up_on == 1) {
    digitalWrite(UpPin, HIGH);
  }

  if (up_on == 0) {
    digitalWrite(UpPin, LOW);
  }

  if (down_on == 1) {
    digitalWrite(DownPin, HIGH);
  }

  if (down_on == 0) {
    digitalWrite(DownPin, LOW);
  }

  if (left_on == 1) {
    digitalWrite(LeftPin, HIGH);
  }

  if (left_on == 0) {
    digitalWrite(LeftPin, LOW);
  }

  if (right_on == 1) {
    digitalWrite(RightPin, HIGH);
  }

  if (right_on == 0) {
    digitalWrite(RightPin, LOW);
  }

//データー受信
  if (Serial1.available() > 0) { // データの受信を確認
    serialData = Serial1.read();
   // Serial.println(serialData);

    //MP-101 control
    if (serialData == UP_BOT) {
      up_on = 1;
    }
    if (serialData == DOWN_BOT) {
      down_on = 1;
    }
    if (serialData == LEFT_BOT) {
      left_on = 1;
    }
    if (serialData == RIGHT_BOT) {
      right_on = 1;
    }
    if (serialData == UP_BOT_off) {
      up_on = 0;
    }
    if (serialData == DOWN_BOT_off) {
      down_on = 0;
    }
    if (serialData == LEFT_BOT_off) {
      left_on = 0;
    }
    if (serialData == RIGHT_BOT_off) {
      right_on = 0;
    }

    //MP-101 speed control
    if (serialData == MP_speed_low) {
      MP_speed = MP_speed_low;
      digitalWrite(speedPin, HIGH); //speed low
      //   digitalWrite(LED, HIGH); //消灯
    }
    else if (serialData == MP_speed_high) {
      MP_speed = MP_speed_high;
      digitalWrite(speedPin, LOW); //speed high
      //   digitalWrite(LED, LOW); //点等
    }

    // Zoom_farの動作
    if (serialData == Zoom_far_high) {
      zoom_far_on = 1;
    }
    if (serialData == Zoom_far_mid) {
      zoom_far_on = 2;
    }
    if (serialData == Zoom_far_low) {
      zoom_far_on = 3;
    }
    if (serialData == Zoom_far_off) {
      zoom_far_on = 0;
    }


    // Zoom_nearの動作

    if (serialData == Zoom_near_high) {
      zoom_near_on = 1;
    }
    if (serialData == Zoom_near_mid) {
      zoom_near_on = 2;
    }
    if (serialData == Zoom_near_low) {
      zoom_near_on = 3;
    }
    if (serialData == Zoom_near_off) {
      zoom_near_on = 0;
    }

    if (serialData == WIDE) {
      wide_on = 1;
    }
    if (serialData == TELE) {
      tele_on = 1;
    }

    if (serialData == WIDE_off) {
      wide_on = 0;
    }
    if (serialData == TELE_off) {
      tele_on = 0;
    }

    //LANCが生きているときだけ
    if  (pulseIn(lancPin, HIGH, 10000) > 0) {

      if (serialData == AFMF) {
        send(B00101000, B01000001); //send a command to camera AF/MF
      }

      if (serialData == ASS1) {
        send(B00101000, B10110001); //send a command to ASS1
      }

      //LANCが生きているときに返事する
      LANC_HTBT = true;
    }
    else
    {
      LANC_HTBT = false;
    }

    if (serialData == HTBT and LANC_HTBT == true) {
      Serial1.print(LANC);
      digitalWrite(linkLED, HIGH);
      link_timer = millis();  //LINKタイマーリセット
    }

    if (serialData == HTBT and LANC_HTBT == false) {
      Serial1.print(HTBT);
      digitalWrite(linkLED, HIGH);
      link_timer = millis();  //LINKタイマーリセット
    }
  }
  //link　lost
  else {
    if ((millis() - link_timer) > 3000) {
      digitalWrite(linkLED, HIGH); //点滅
      delay(200);
      digitalWrite(linkLED, LOW); //点滅
      delay(200);
    }

  }
}

void send(unsigned char cmd1, unsigned char cmd2)
{
  for (int     cmdRepeatCount = 0; cmdRepeatCount < 5; cmdRepeatCount++) {  //repeat 5 times to make sure the camera accepts the command

    while (pulseIn(lancPin, HIGH) < 5000) {
      //"pulseIn, HIGH" catches any 0V TO +5V TRANSITION and waits until the LANC line goes back to 0V
      //"pulseIn" also returns the pulse duration so we can check if the previous +5V duration was long enough (>5ms) to be the pause before a new 8 byte data packet
      //Loop till pulse duration is >5ms
    }

    //LOW after long pause means the START bit of Byte 0 is here
    delayMicroseconds(bitDuration);  //wait START bit duration

    for ( int i = 0; i < 8; i++) {
      digitalWrite(cmdPin, (cmd1 & (1 << i) ) ? HIGH : LOW); //Write bit 0.
      delayMicroseconds(bitDuration);
    }

    //Byte 0 is written now put LANC line back to +5V
    digitalWrite(cmdPin, LOW);
    delayMicroseconds(10); //make sure to be in the stop bit before byte 1

    while (digitalRead(lancPin)) {
      //Loop as long as the LANC line is +5V during the stop bit
    }

    //0V after the previous stop bit means the START bit of Byte 1 is here
    delayMicroseconds(bitDuration);  //wait START bit duration

    for ( int i = 0; i < 8; i++) {
      digitalWrite(cmdPin, (cmd2 & (1 << i) ) ? HIGH : LOW); //Write bit 0.
      delayMicroseconds(bitDuration);
    }
    //Byte 1 is written now put LANC line back to +5V
    digitalWrite(cmdPin, LOW);

    /*Control bytes 0 and 1 are written, now don’t care what happens in Bytes 2 to 7
      and just wait for the next start bit after a long pause to send the first two command bytes again.*/


  }//While cmdRepeatCount < 5
}

bool xbeecmd_enter()//ATモードにするための開始コマンド
{
  //delay (110);
  XBEE_SERIAL.print("+++");
  return dumpReply();
}

bool xbeecmd_CMD(String cmd)//ATコマンドを送るだけ\rを最後につけて送る
{
  XBEE_SERIAL.print(cmd);
  XBEE_SERIAL.print("\r");
  return dumpReply();
}
bool dumpReply()
{
  String label;
  char dat[255];   // 格納用文字列
  int count = 0;  // 文字数のカウンタ

  unsigned long time;

  time = millis();
  //    mySerial.println(time);
  while ((millis() - time) < 3000) {
    if (XBEE_SERIAL.available()) {
      dat[count] = XBEE_SERIAL.read();
      if (dat[count] == '\r') {
        label = dat;
        break;
      }
      else {
        count++;                              // 文字カウンタに 1 加算
      }
    }
  }
  //      mySerial.println(millis());
  if (label == "") // timeout
  {
    return false;
  }
  else
  {
    xbee_ret = label;
    return true;
  }
}
